// Reads lines from cin and prints each line, reversed by words, on cout.

#include "string_list.h"
#include <iostream>
#include <sstream>

using namespace std;

// Splits a string on spaces, returning a list of the words in reverse.
string_list::List split_line_rev(const string& line)
{
    istringstream line_stream(line);
    string_list::List word_list;
    string word;

    while (line_stream >> word)
        word_list = cons(word, word_list);

    return word_list;
}

// Writes the strings in a string list with spaces in between and a newline
// at the end.
void write_line_list(string_list::List lst)
{
    while (is_cons(lst)) {
        cout << lst->first;
        if (is_cons(lst->rest)) cout << ' ';
        lst = lst->rest;
    }

    cout << '\n';
}

int main()
{
    string line;

    while (getline(cin, line)) {
        string_list::List word_list = split_line_rev(line);
        write_line_list(word_list);
    }
}